"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuestionnaireAnswer = exports.NewQuestionnaireAnswer = exports.QuestionnaireQuestion = exports.QuestionnaireWithAnswers = exports.Questionnaire = exports.EQuestionnaireQuestionType = exports.EQuestionnaireStatus = void 0;
var EQuestionnaireStatus;
(function (EQuestionnaireStatus) {
    EQuestionnaireStatus[EQuestionnaireStatus["Available"] = 0] = "Available";
    EQuestionnaireStatus[EQuestionnaireStatus["Complete"] = 1] = "Complete";
})(EQuestionnaireStatus || (exports.EQuestionnaireStatus = EQuestionnaireStatus = {}));
var EQuestionnaireQuestionType;
(function (EQuestionnaireQuestionType) {
    EQuestionnaireQuestionType[EQuestionnaireQuestionType["MultipleChoice"] = 0] = "MultipleChoice";
    EQuestionnaireQuestionType[EQuestionnaireQuestionType["Location"] = 1] = "Location";
})(EQuestionnaireQuestionType || (exports.EQuestionnaireQuestionType = EQuestionnaireQuestionType = {}));
class Questionnaire {
    constructor(
    /**
     * The questionnaire is uniquely identified by it's CID in IPFS. This is the primary key for
     * questionnaires.
     */
    id, // the location of the questionnaire in IPFS
    marketplaceTag, // The tag that
    status, 
    /// The questions are entirely part of the Questionnaire and not an independent object.
    questions) {
        this.id = id;
        this.marketplaceTag = marketplaceTag;
        this.status = status;
        this.questions = questions;
    }
}
exports.Questionnaire = Questionnaire;
class QuestionnaireWithAnswers extends Questionnaire {
    constructor(id, marketplaceTag, status, questions, 
    // The answers are independent objects; they are included as part of the Questionnaire for
    // convenience, but they are not required to be included in the Questionnaire.
    answers) {
        super(id, marketplaceTag, status, questions);
        this.answers = answers;
    }
}
exports.QuestionnaireWithAnswers = QuestionnaireWithAnswers;
class QuestionnaireQuestion {
    constructor(index, type, text, choices) {
        this.index = index;
        this.type = type;
        this.text = text;
        this.choices = choices;
    }
}
exports.QuestionnaireQuestion = QuestionnaireQuestion;
class NewQuestionnaireAnswer {
    constructor(questionnaireId, questionIndex, choice, measurementDate) {
        this.questionnaireId = questionnaireId;
        this.questionIndex = questionIndex;
        this.choice = choice;
        this.measurementDate = measurementDate;
    }
}
exports.NewQuestionnaireAnswer = NewQuestionnaireAnswer;
class QuestionnaireAnswer extends NewQuestionnaireAnswer {
    constructor(id, questionnaireId, questionIndex, choice, measurementDate) {
        super(questionnaireId, questionIndex, choice, measurementDate);
        this.id = id;
        this.questionnaireId = questionnaireId;
        this.questionIndex = questionIndex;
        this.choice = choice;
        this.measurementDate = measurementDate;
    }
}
exports.QuestionnaireAnswer = QuestionnaireAnswer;
//# sourceMappingURL=Questionnaire.js.map